"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var src_exports = {};
__export(src_exports, {
  modulePluginVue: () => modulePluginVue
});
module.exports = __toCommonJS(src_exports);
var import_plugin_module_babel = require("@modern-js/plugin-module-babel");
var import_esbuild_plugin_vue3 = __toESM(require("esbuild-plugin-vue3"));
const modulePluginVue = (options) => ({
  name: "vue-plugin",
  usePlugins: [
    (0, import_plugin_module_babel.modulePluginBabel)({
      plugins: [
        [
          require("@babel/plugin-syntax-typescript"),
          {
            isTSX: true
          }
        ],
        [
          require("@vue/babel-plugin-jsx"),
          {
            ...options === null || options === void 0 ? void 0 : options.vueJsxPluginOptions
          }
        ]
      ]
    })
  ],
  setup: () => ({
    beforeBuildTask(config) {
      const lastEsbuildOptions = config.esbuildOptions;
      config.esbuildOptions = (c) => {
        var _lastEsbuildConfig_plugins;
        const lastEsbuildConfig = lastEsbuildOptions(c);
        (_lastEsbuildConfig_plugins = lastEsbuildConfig.plugins) === null || _lastEsbuildConfig_plugins === void 0 ? void 0 : _lastEsbuildConfig_plugins.unshift((0, import_esbuild_plugin_vue3.default)());
        return lastEsbuildConfig;
      };
      config.jsx = "preserve";
      return config;
    }
  })
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  modulePluginVue
});
